﻿Type=Class
Version=2
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module

Sub Class_Globals
	Private c_ComboText As TextField
	Private c_TV As TableView

	Private c_Arrow As ImageView
	Private c_Panel As Panel
	Private c_DropHeight As Int, c_dropped As Boolean =False
	Private c_TextHeight As Int =0 
	Private c_InitCounter As Int =0
	
End Sub

'The combo object consists of a Textfield box, a dropdown icon, and a tableview
'These objects will be placed on the Initialised panel passed as a parameter
'The TextField is used to display the results of the selection
'DropDownRows is the number of rows to display when the combop box is dropped down
'The Tableview is initialised from the text array in the list 'items'
'The zeroth element of the list is used a prompt for the data to be entered
'The StdIcon if present will be displayed against each list item
Public Sub Initialize(myPanel As Panel,myText As TextField, myTable As TableView,DropDownRows As Int,items As List,StdIcon As Bitmap)
	c_InitCounter=c_InitCounter+1
	'Set minimum dropheight

	If myText.tag=Null Then
		'We need to save the initial panel height when first invoked since we change its height when the combo is dropped down
		'Remember the initial height in the textfield tag property - local variables will not persist between initialisations
		myText.tag=myPanel.Height
		c_TextHeight=myPanel.Height
	Else
		c_TextHeight=myText.tag
	End If
	
	'Try to prevent dropdown externding beyond the bottom of the screen - it must be possible to select the last item!
	'Calculate how many rows would fit to the bottom of the screen from where the panel is now, and adjust if necessary
	Dim no As NativeObject = myPanel
	Dim parent As View = no.GetField("superview")	
	Dim PossRows=Floor((parent.Height-myPanel.Top)/c_TextHeight)-1 As Int
	'Log("Poss rows: " & PossRows)
	DropDownRows=Min(PossRows,DropDownRows)

	c_DropHeight=DropDownRows*c_TextHeight
	
	
	c_Panel=myPanel
	c_Panel.Visible=True

	c_TV=myTable
	c_TV.RowHeight=c_TextHeight
	c_ComboText=myText
	c_TV.Width=myPanel.width
	
	c_ComboText.Height=c_TextHeight
	c_ComboText.width=myPanel.Width
	'c_ComboText.Color=Colors.Transparent
	
	c_Arrow.Initialize("Arrow")
	c_Arrow.Bitmap=LoadBitmap(File.DirAssets,"downsmall.png")

	c_Arrow.Alpha=0.5
	c_Panel.Height=c_TextHeight
	c_Panel.RemoveAllViews
	c_Panel.AddView(c_Arrow,myTable.Width-c_TextHeight,1,c_TextHeight,c_TextHeight)
	c_Panel.AddView(c_ComboText,1,1,myTable.Width,c_TextHeight)
	c_Arrow.BringToFront
	
	myTable.Top=c_Panel.Top+c_ComboText.Height
	myTable.Left=c_Panel.left
	myTable.Color=Colors.LightGray
	myTable.RowHeight=c_TextHeight

	Dim ptop=c_ComboText.Height As Int
	Dim pwidth=c_ComboText.Width As Int
	Dim pHeight=c_TextHeight As Int
	c_Panel.AddView(myTable,0,ptop,pwidth,pHeight)
	
	'Uncomment this if you want the first item to be shown in the normal font
	'c_ComboText.Text=items.Get(0)
	
	c_ComboText.HintText=items.Get(0)
	myTable.AddSection(items.Get(0),"")
	Dim i As Int
	
	'Log("========= Adding list ==========")
	For i = 1 To items.Size-1
		Dim Item As String=items.Get(i)
		Dim tc As TableCell = myTable.AddSingleLine(Item)
		If StdIcon.IsInitialized Then tc.Bitmap = StdIcon

		'Log("Adding Item "& i & ": " & items.Get(i))
		'Dim tc As TableCell = mytable.AddTwoLines("First line", "Second line") 
		'tc.Bitmap = img
		'mytable.AddSection("Section " & i,"--- End of Section  ---")
	'     'create an item and customize it
	'     Dim tc As TableCell = mytable.AddTwoLines("First line", "") 'the second line will be soon added
	'     tc.Bitmap = img
	'     tc.IndentationLevel = Rnd(0, 5)
	'     Dim ColoredTitle As AttributedString
	'     ColoredTitle.Initialize("Second line", Font.CreateNew(19), Rnd(0x80000000, -1))
	'     tc.DetailText = ColoredTitle
	Next

	myTable.ReloadAll
	
End Sub

'This will add a one line item to the end of the combo-box
'If the image is initialised with a bitmap, then it will be added to the element
Sub AddSingleLine(itemtext As String,image As Bitmap)
	Dim tc As TableCell = c_TV.AddSingleLine(itemtext)
	If image.IsInitialized Then
		tc.Bitmap = image
	End If
	c_TV.ReloadSection(c_TV.NumberOfSections-1)
End Sub

'This will add a two line item to the end of the combo-box
'If the image is initialised with a bitmap, then it will be added to the element
Sub AddTwoLines(itemtext1 As String,itemtext2 As String,image As Bitmap)
	Dim tc As TableCell = c_TV.AddTwoLines(itemtext1,itemtext2)
	If image.IsInitialized Then
		tc.Bitmap = image
	End If
	c_TV.ReloadSection(c_TV.NumberOfSections-1)
End Sub

Sub Arrow_Click
	c_dropped=Not(c_dropped)
	'Log("Clicked Arrow: Dropped " & c_dropped)
	If c_dropped Then
		c_TV.Height=c_DropHeight
		'Make sure last item is visible
		c_Panel.Height=c_DropHeight+c_TextHeight
		c_Panel.BringToFront
		c_Arrow.Bitmap=LoadBitmap(File.DirAssets,"upsmall.png")
	
	Else
		c_Panel.Height=c_TextHeight
		c_Arrow.Bitmap=LoadBitmap(File.DirAssets,"downsmall.png")
	End If	
End Sub

public Sub setVisible(Visible As Boolean)
	c_Panel.Visible=Visible
End Sub
	
public Sub getVisible  As Boolean
	Return c_Panel.Visible 
End Sub

'Updates the text area based on the current selection
'NB This requires to be called from outside the class module
'as events cannot be used within the Class module
Sub Update
	Dim MySelection As String = c_TV.SelectedRow.Text.ToString
	Log("Selected Text was " & MySelection )
	c_ComboText.Text=MySelection
	Arrow_Click
End Sub

public Sub Selection As String
	Return c_TV.SelectedRow.Text.ToString
End Sub

'Clears the text area and cancels the dropdown
Sub Clear
	c_ComboText.Text=""
	If c_dropped Then Arrow_Click
End Sub
	
